Index: pacemaker/pengine/test10/use-after-free-merge.exp
===================================================================
--- pacemaker.orig/pengine/test10/use-after-free-merge.exp
+++ pacemaker/pengine/test10/use-after-free-merge.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="10" operation="start" operation_key="fencing-sbd_start_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="fencing-sbd" class="stonith" type="external/sbd"/>
-        <attributes CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
+        <attributes CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="fencing-sbd_monitor_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="fencing-sbd" class="stonith" type="external/sbd"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
+        <attributes CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="2" operation="monitor" operation_key="fencing-sbd_monitor_0" on_node="hex-13" on_node_uuid="hex-13">
         <primitive id="fencing-sbd" class="stonith" type="external/sbd"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
+        <attributes CRM_meta_on_node="hex-13" CRM_meta_on_node_uuid="hex-13" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000280000"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -37,7 +37,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="d0_monitor_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="d0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -46,7 +46,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="d0_monitor_0" on_node="hex-13" on_node_uuid="hex-13">
         <primitive id="d0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hex-13" CRM_meta_on_node_uuid="hex-13" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -55,7 +55,7 @@
     <action_set>
       <rsc_op id="8" operation="monitor" operation_key="d1_monitor_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="d1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -64,7 +64,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="d1_monitor_0" on_node="hex-13" on_node_uuid="hex-13">
         <primitive id="d1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hex-13" CRM_meta_on_node_uuid="hex-13" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -73,7 +73,7 @@
     <action_set>
       <rsc_op id="15" operation="start" operation_key="s0:0_start_0" on_node="hex-13" on_node_uuid="hex-13">
         <primitive id="s0" long-id="s0:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="hex-13" CRM_meta_on_node_uuid="hex-13" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -86,7 +86,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="s0:0_monitor_0" on_node="hex-13" on_node_uuid="hex-13">
         <primitive id="s0" long-id="s0:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="hex-13" CRM_meta_on_node_uuid="hex-13" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -95,7 +95,7 @@
     <action_set>
       <rsc_op id="16" operation="start" operation_key="s0:1_start_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -108,7 +108,7 @@
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="s0:1_monitor_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/utilization-check-allowed-nodes.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-check-allowed-nodes.exp
+++ pacemaker/pengine/test10/utilization-check-allowed-nodes.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="8" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -37,7 +37,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -46,7 +46,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc2_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/utilization-order1.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-order1.exp
+++ pacemaker/pengine/test10/utilization-order1.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc2_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/utilization-order2.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-order2.exp
+++ pacemaker/pengine/test10/utilization-order2.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc4_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc4" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="6" operation="start" operation_key="rsc3_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -32,7 +32,7 @@
     <action_set>
       <rsc_op id="5" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -41,7 +41,7 @@
     <action_set>
       <rsc_op id="7" operation="stop" operation_key="rsc2:1_stop_0" internal_operation_key="rsc2:0_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" long-id="rsc2:1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -77,7 +77,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="rsc1_stop_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/utilization-order3.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-order3.exp
+++ pacemaker/pengine/test10/utilization-order3.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc2_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="8" operation="migrate_from" operation_key="rsc1_migrate_from_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="7" operation="migrate_to" operation_key="rsc1_migrate_to_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -60,7 +60,7 @@
     <action_set>
       <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/utilization-order4.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-order4.exp
+++ pacemaker/pengine/test10/utilization-order4.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="18" operation="migrate_from" operation_key="degllx62-vm_migrate_from_0" on_node="deglxen001" on_node_uuid="deglxen001">
         <primitive id="degllx62-vm" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="deglxen002" CRM_meta_migrate_target="deglxen001" CRM_meta_name="migrate_from" CRM_meta_record_pending="false" CRM_meta_timeout="1800000"  xmfile="/etc/xen/vm/degllx62"/>
+        <attributes CRM_meta_migrate_source="deglxen002" CRM_meta_migrate_target="deglxen001" CRM_meta_name="migrate_from" CRM_meta_on_node="deglxen001" CRM_meta_on_node_uuid="deglxen001" CRM_meta_record_pending="false" CRM_meta_timeout="1800000"  xmfile="/etc/xen/vm/degllx62"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="17" operation="migrate_to" operation_key="degllx62-vm_migrate_to_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="degllx62-vm" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="deglxen002" CRM_meta_migrate_target="deglxen001" CRM_meta_name="migrate_to" CRM_meta_record_pending="false" CRM_meta_timeout="1800000"  xmfile="/etc/xen/vm/degllx62"/>
+        <attributes CRM_meta_migrate_source="deglxen002" CRM_meta_migrate_target="deglxen001" CRM_meta_name="migrate_to" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="1800000"  xmfile="/etc/xen/vm/degllx62"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="16" operation="monitor" operation_key="degllx62-vm_monitor_30000" on_node="deglxen001" on_node_uuid="deglxen001">
         <primitive id="degllx62-vm" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx62"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="deglxen001" CRM_meta_on_node_uuid="deglxen001" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx62"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -60,7 +60,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="degllx62-vm_stop_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="degllx62-vm" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx62"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx62"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -73,7 +73,7 @@
     <action_set>
       <rsc_op id="19" operation="stop" operation_key="degllx61-vm_stop_0" on_node="deglxen001" on_node_uuid="deglxen001">
         <primitive id="degllx61-vm" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx61"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="deglxen001" CRM_meta_on_node_uuid="deglxen001" CRM_meta_record_pending="false" CRM_meta_timeout="120000"  xmfile="/etc/xen/vm/degllx61"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -115,7 +115,7 @@
     <action_set>
       <rsc_op id="32" operation="stop" operation_key="nfs-xen_config:1_stop_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="nfs-xen_config" long-id="nfs-xen_config:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap098nfs:/vol/xen_config" directory="/etc/xen/vm" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap098nfs:/vol/xen_config" directory="/etc/xen/vm" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -131,7 +131,7 @@
     <action_set>
       <rsc_op id="33" operation="stop" operation_key="nfs-xen_swapfiles:1_stop_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="nfs-xen_swapfiles" long-id="nfs-xen_swapfiles:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap098nfs:/vol/xen_swapfiles" directory="/var/lib/xen/deglnap098_swapfiles" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap098nfs:/vol/xen_swapfiles" directory="/var/lib/xen/deglnap098_swapfiles" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -147,7 +147,7 @@
     <action_set>
       <rsc_op id="34" operation="stop" operation_key="nfs-xen_images:1_stop_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="nfs-xen_images" long-id="nfs-xen_images:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap099nfs:/vol/xen_images" directory="/var/lib/xen/deglnap099_images" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  device="deglnap099nfs:/vol/xen_images" directory="/var/lib/xen/deglnap099_images" fstype="nfs" options="rw,bg,hard,nointr,rsize=32768,wsize=32768,tcp,nfsvers=3,timeo=600"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -190,7 +190,7 @@
     <action_set>
       <rsc_op id="45" operation="stop" operation_key="prim-ping:0_stop_0" internal_operation_key="prim-ping:1_stop_0" on_node="deglxen002" on_node_uuid="deglxen002">
         <primitive id="prim-ping" long-id="prim-ping:0" class="ocf" provider="pacemaker" type="ping"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  host_list="77.77.77.138 77.77.77.139" multiplier="2000" name="ping-hosts"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="deglxen002" CRM_meta_on_node_uuid="deglxen002" CRM_meta_record_pending="false" CRM_meta_timeout="60000"  host_list="77.77.77.138 77.77.77.139" multiplier="2000" name="ping-hosts"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/utilization-shuffle.exp
===================================================================
--- pacemaker.orig/pengine/test10/utilization-shuffle.exp
+++ pacemaker/pengine/test10/utilization-shuffle.exp
@@ -41,7 +41,7 @@
     <action_set>
       <rsc_op id="109" operation="monitor" operation_key="prmExPostgreSQLDB1_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmExPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -54,7 +54,7 @@
     <action_set>
       <rsc_op id="108" operation="start" operation_key="prmExPostgreSQLDB1_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmExPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -70,7 +70,7 @@
     <action_set>
       <rsc_op id="111" operation="monitor" operation_key="prmFsPostgreSQLDB1-1_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -83,7 +83,7 @@
     <action_set>
       <rsc_op id="110" operation="start" operation_key="prmFsPostgreSQLDB1-1_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -99,7 +99,7 @@
     <action_set>
       <rsc_op id="113" operation="monitor" operation_key="prmFsPostgreSQLDB1-2_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -112,7 +112,7 @@
     <action_set>
       <rsc_op id="112" operation="start" operation_key="prmFsPostgreSQLDB1-2_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -128,7 +128,7 @@
     <action_set>
       <rsc_op id="115" operation="monitor" operation_key="prmFsPostgreSQLDB1-3_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -141,7 +141,7 @@
     <action_set>
       <rsc_op id="114" operation="start" operation_key="prmFsPostgreSQLDB1-3_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmFsPostgreSQLDB1-3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -157,7 +157,7 @@
     <action_set>
       <rsc_op id="117" operation="monitor" operation_key="prmIpPostgreSQLDB1_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmIpPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -170,7 +170,7 @@
     <action_set>
       <rsc_op id="116" operation="start" operation_key="prmIpPostgreSQLDB1_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmIpPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -186,7 +186,7 @@
     <action_set>
       <rsc_op id="119" operation="monitor" operation_key="prmApPostgreSQLDB1_monitor_5000" on_node="act3" on_node_uuid="act3">
         <primitive id="prmApPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -199,7 +199,7 @@
     <action_set>
       <rsc_op id="118" operation="start" operation_key="prmApPostgreSQLDB1_start_0" on_node="act3" on_node_uuid="act3">
         <primitive id="prmApPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="act3" CRM_meta_on_node_uuid="act3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
